"""Basic PorousMaterials input generator."""
import os
from string import Template
from copy import deepcopy


class PorousMaterialsInput:
    """
    PorousMaterials Input generator.
    It takes parameters as the dictionary and
    also reads the template, and then generates
    necessary variables and then replace them in the Template
    and creates the input for the calculation.
    """

    def __init__(self, params):
        self.params = deepcopy(params)

    def render(self):
        """
        Performing the described tasks.
        """

        output = "### Generated by AiiDA ###"
        output += ""
        params = deepcopy(self.params)

        basepath = os.path.dirname(os.path.abspath(__file__))
        tmppath = '{}/templates/{}.jl'.format(basepath, self.params['input_template'])

        with open(tmppath) as template:
            lines = template.read()

        inp = Template(lines).substitute(params)
        output += inp
        return output


# EOF
